//***********************************************************************//
//	CGI in C for Linux (MDK 9.2)
//	Author:	YB 2004
//	Mail:	yb_net@yahoo.fr
//	Web :	http://www.ybnet.fr.st
//	Program: ctrlcam (gcc)
//	Description:	simple CGI : stepper motor & temperature sensor  //
//	Date:	24/04/04
//***********************************************************************//
// ctrlcam.c : Defines the entry point for the console application.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <time.h>
// --
#include "MyGlobals.h"
#include "MyTypes.h"
#include "lowlevel.h"
#include "thermometre_DS1720.h"


main(int argc, char **argv)
{
	FILE 	*fp;
	char 	TempBuff[400]="";
	time_t 	ltime;
	char    *TestLeft="ACTION=LEFT";
	char    *TestRight="ACTION=RIGHT";
	char    *TestTop="ACTION=UP";
	char    *TestBottom="ACTION=DOWN";
	char    *TestRefresh="ACTION=REFRESH";
	char    *TestGet="GET";
	char    *TestCmd="";
	char	TmpCmd1[100]="";
	u32	LenRequestMethod,LenQueryString,LenRemoteHost,LenRemoteAddress;

// Send headers to the client
	printf("Content-type: text/html\r\n\r\n");

// Begin sending back HTML to the client
	//printf("%s",header);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\r\n\r\n<HTML>\r\n<HEAD>\r\n<TITLE>Appartement</TITLE>\r\n<META NAME=\"subject\" CONTENT=\"Webcam\">\r\n<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\r\n<META HTTP-EQUIV=\"expires\" CONTENT=\"Wed, 26 Feb 1997 08:21:57 GMT\">\r\n<meta http-equiv=\"Refresh\" content=\"69; URL=/cgi-bin/ctrlcam?ACTION=REFRESH\">\r\n</HEAD>\r\n<BODY  BGCOLOR=\"#1C2752\" TEXT=\"#EEEEEE\" LINK=\"#000080\" VLINK=\"#00D502\" ALINK=\"#FF0000\">\r\n\r\n<CENTER>\r\n<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=\"350\">\r\n");

// Version Formulaire
	printf("<TR>\r\n<TD ALIGN=Center VALIGN=TOP WIDTH=\"350\">\r\n		<CENTER>\r\n		<FORM METHOD=GET ACTION=\"/cgi-bin/ctrlcam\">\r\n			<TABLE BORDER=0 CELLPADDING=10>\r\n			<TR>\r\n				<TD ALIGN=Center VALIGN=Middle>\r\n					<INPUT  NAME=ACTION  TYPE=submit  VALUE=LEFT>\r\n				</TD>\r\n				<TD ALIGN=Center VALIGN=Middle BGCOLOR=#1F2B5F>\r\n					<FONT COLOR=#FF8A00 SIZE=+2>+</FONT>\r\n				</TD>\r\n				<TD ALIGN=Center VALIGN=Middle>\r\n					<INPUT  NAME=ACTION  TYPE=submit  VALUE=RIGHT>\r\n				</TD>\r\n			</TR>\r\n			</TABLE>\r\n		</FORM>\r\n		</CENTER>\r\n	</TD>\r\n</TR>\r\n</TABLE>\r\n</CENTER>\r\n\r\n\r\n");


	// read the command from the client
	// vrifications / robustesse...
	LenRequestMethod=strlen(strncpy(TmpCmd1, REQUEST_METHOD,99));
	LenQueryString=strlen(strncpy(TmpCmd1, QUERY_STRING,99));
	LenRemoteHost=strlen(strncpy(TmpCmd1, REMOTE_HOST,99));
	LenRemoteAddress=strlen(strncpy(TmpCmd1, REMOTE_ADDR,99));

	// vrif port //
	ErreurEndLevel=InitMount();

	// on vrifi que la requete est correcte et le driver dispo
	if( 	(REQUEST_METHOD != NULL) &&
		(LenRequestMethod <= 10) &&
		(QUERY_STRING != NULL) &&
		(LenQueryString <= 20) &&
		(strcmp("", REQUEST_METHOD) != 0) &&
		(strcmp("", QUERY_STRING) != 0) &&
		(LenRemoteHost <= 99) &&
		(LenRemoteAddress<= 20) &&
		(ErreurEndLevel != CNOK) )
	{
	// **************** dbut zone protge *********************
		if( strcmp(TestGet, REQUEST_METHOD) == 0 ) //parse only if there is a method from the client
		//parse only if there is a method from the client
		{

			// send the usefull server variables
			time( &ltime );
			strncpy( DateTime, ctime( &ltime ), 24);

			// commandes
			if(strcmp(TestLeft, QUERY_STRING) == 0) //parse only if it's a GET method from the client
			{
				// turn the webcam left
				ErreurEndLevel=GoLeft();
				printf ("<CENTER><FONT>Webcam is turning left...</FONT></CENTER>\r\n");
				if ( (fp = fopen("lastmove.txt","w+")) == NULL)
				{
					printf("Error: can't open lastmove.txt for writing.");
				}
				else
				{
					fprintf(fp,"%s \r\n<BR>(IP: %s - Date: %s - Direction: Left)", REMOTE_HOST, REMOTE_ADDR, DateTime);
					fclose(fp);
				}
			}
			else if(strcmp(TestRight, QUERY_STRING) == 0)
			{
				// turn the webcam right
				ErreurEndLevel=GoRight();
				printf ("<CENTER><FONT>Webcam is turning right...</FONT></CENTER>\r\n");
				if ( (fp = fopen("lastmove.txt","w+")) == NULL)
				{
					printf("Error: can't open lastmove.txt for writing.");
				}
				else
				{
					fprintf(fp,"%s \r\n<BR>(IP: %s - Date: %s - Direction: Right)", REMOTE_HOST, REMOTE_ADDR, DateTime);
					fclose(fp);
				}
			}
			else if(strcmp(TestTop, QUERY_STRING) == 0)
			{
				// turn the webcam up
				//ErreurEndLevel=GoUp();
				printf ("<CENTER><FONT>Up action is not mechanicaly implemented, try again ! </FONT></CENTER><br>\r\n");
			}
			else if(strcmp(TestBottom, QUERY_STRING) == 0)
			{
				// turn the webcam down
				//ErreurEndLevel=GoDown();
				printf ("<CENTER><FONT>Down action is not mechanicaly implemented, try again ! </FONT></CENTER><br>\r\n");
			}
			//else if(strcmp(TestRefresh, QUERY_STRING) == 0)
			//{
			//}
			else
			{
			}



		}
		else
		{
			printf ("<CENTER><FONT>Incorrect method, try again with GET!</FONT></CENTER><br>\r\n");
		}

		// log Lastmove by
		if ( (fp = fopen("lastmove.txt","r")) == NULL)
		{
				printf("Error: can't open lastmove.txt for reading.");
		}
		else
		{
			//fscanf( fp, "%s", TempBuff );
			fread( TempBuff, sizeof( char ), 200, fp );
			printf("\r\n<CENTER><FONT>Last move by : %s </FONT></CENTER>",TempBuff);
			fclose(fp);
		}

		//lecture du conf register et vrif de la puce
		//ReadConfReg();

		//lecture temprature du DS1720

		temp1=ReadThermo();
		if(temp1>=256)
			temp1-=512;
		tempc=((float)temp1/2);
		//printf("temp1=%d", temp1);
		printf("<CENTER><FONT>Temprature de la pice = %.1f C</FONT></CENTER><br>\r\n",tempc);


	// **************** fin zone protge *********************
	}
	else if (ErreurEndLevel == OPEN_DRIVER_READ_ERR)
	{
		printf ("<CENTER><FONT>Unable to open the device... azimuth mecanism disabled \n</FONT></CENTER><br>\r\n");
	}

	/*
			printf ("REQUEST_METHOD : %s <br>\r\n ", REQUEST_METHOD);
			printf ("QUERY_STRING : %s <br>\r\n", QUERY_STRING);
			printf("%s - %s", TmpCmd1, TestCmd);

			printf ("REMOTE_ADDR : %s <br>\r\n", REMOTE_ADDR);
			printf ("REMOTE_HOST : %s <br>\r\n", REMOTE_HOST);
			printf ("REMOTE_USER : %s <br>\r\n", REMOTE_USER);
			printf ("SERVER_SOFTWARE : %s <br>\r\n", SERVER_SOFTWARE);
			printf ("SERVER_NAME : %s <br>\r\n", SERVER_NAME);
			printf ("SERVER_PORT : %s <br>\r\n", SERVER_PORT);
			printf ("<hr>\r\n");
*/


	// Ending sending back HTML to the client
	//printf("%s",footer);
	printf("\r\n\r\n</BODY>\r\n</HTML>");

/*
	//criture d'un fichier log pour surveiller l'activit
	if ( (fp = fopen("camctrl.txt","a+")) == NULL)
	{
        	printf("Error: can't open camctrl.txt for writing.");
    	}
	else
	{
		/*time( &ltime );
		strncpy( DateTime, ctime( &ltime ), 24);
		*/
		/*fprintf(fp,"%s - URL: %s - REMOTE_ADDR: %s - REQUEST_METHOD: %s - QUERY_STRING: %s - REMOTE_HOST: %s - SERVER_NAME: %s - SERVER_PORT: %s - SERVER_PORT_SECURE: %s -  SERVER_PROTOCOL: %s - SERVER_SOFTWARE: %s \n", DateTime, URL, REMOTE_ADDR, REQUEST_METHOD, QUERY_STRING, REMOTE_HOST, SERVER_NAME, SERVER_PORT, SERVER_PORT_SECURE, SERVER_PROTOCOL, SERVER_SOFTWARE );
		fclose(fp);
    	}
	*/
}


