//***********************************************************************//
//																		 //
//		            - CGI in C for Windows NT (9x) - 				     //
//                                                                       //
//		Author:			YB 2002									         //
//																		 //
//		Mail:			yb_net@yahoo.fr									 //
//																		 //
//		Web :			http://www.ybnet.fr.st							 //
//																		 //
//		Program:		ctrlcamL  								         //
//																		 //
//		Description:	simple CGI : stepper motor & temperature sensor  //
//																		 //
//		Date:			01/10/02										 //
//																		 //
//***********************************************************************//
// ctrlcam.cpp : Defines the entry point for the console application.
//
//

#include "stdafx.h"
#include <stdlib.h>
#include <iostream>											// Include the standard C++ file
#include <conio.h>
#include <stdio.h>
#include <time.h>

//#include <Winsock2.h>

// Local Header Files
#include "myglobals.h"
#include "MyTypes.h"
#include "lowlevel.h"
#include "thermometre_DS1720.h"


#define SERVER_SOFTWARE getenv("SERVER_SOFTWARE")
#define	REQUEST_METHOD	getenv("REQUEST_METHOD")
#define	QUERY_STRING	getenv("QUERY_STRING")
#define REMOTE_ADDR		getenv("REMOTE_ADDR")
#define REMOTE_HOST		getenv("REMOTE_HOST")
#define REMOTE_USER		getenv("REMOTE_USER")
#define SERVER_NAME		getenv("SERVER_NAME")
#define SERVER_PORT		getenv("SERVER_PORT")
#define REMOTE_USER		getenv("REMOTE_USER")
#define SCRIPT_NAME		getenv("SCRIPT_NAME")
#define URL				getenv("URL")
#define SERVER_PORT_SECURE	getenv("SERVER_PORT_SECURE")
#define SERVER_PROTOCOL	getenv("SERVER_PROTOCOL")


int main(int argc, char* argv[])
{
	  
//	 struct hostent *h;
	time_t ltime;
	FILE *fp;
	DWORD dWindowsVersion;
	//char SERVEUR_VALUE[50]="ircnet.nerim.fr";
	char TempBuff[400]="";

	//Beep(220,50); // beep 600Hz during 100ms

	// dtection de la version de Windows: 
	//WinNT oblige  passer par un driver, Win9x permet l'accs direct  la carte
	dWindowsVersion = GetVersion();
     if (dWindowsVersion < 0x80000000) 
	 {
     // Windows NT
       WindowsVersion=isWindowsNT;     
     } 
	 else if (LOBYTE(LOWORD(dWindowsVersion))<4) 
	 {
     // Win32s
       WindowsVersion=isWindows32;
     }
	else 
	{
    // Windows 95
       WindowsVersion=isWindows95;
    }

	// Send headers to the client
	printf("Content-type: text/html\r\n\r\n");
	//printf("Cache-Control: no-cache\r\n\r\n");
	
	//basic html page
	//sprintf(header,"%s","<HTML>\r\n<HEAD>\r\n<TITLE>CGI : Camera Gizmo Interface</TITLE>\r\n</HEAD>\r\n<BODY BGCOLOR=\"#19205a\" TEXT=\"#ffffff\" LINK=\"#00F080\" VLINK=\"#FF0000\" ALINK=\"Aqua\">\r\n</HEAD>\r\n<CENTER>\r\n<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>\r\n<TR>\r\n<TD ALIGN=Center VALIGN=TOP WIDTH=61%>\r\n<CENTER>\r\n<FORM METHOD=GET ACTION=\"../../cgi-bin/ctrlcam.exe\">\r\n<TABLE BORDER=0 CELLPADDING=10>\r\n<TR>\r\n<TD>\r\n</TD>\r\n<TD>\r\n</TD>\r\n<TD>\r\n</TD>\r\n</TR>\r\n<TR>\r\n<TD ALIGN=Center VALIGN=Middle>\r\n<INPUT  NAME=ACTION  TYPE=submit  VALUE=LEFT>\r\n</TD>\r\n<TD ALIGN=Center VALIGN=Middle BGCOLOR=#1F2B5F>\r\n<FONT COLOR=#FF8A00 SIZE=+2>+</FONT>\r\n</TD>\r\n<TD ALIGN=Center VALIGN=Middle>\r\n<INPUT  NAME=ACTION  TYPE=submit  VALUE=RIGHT>\r\n</TD>\r\n</TR>\r\n<TR>\r\n<TD>\r\n</TD>\r\n<TD>\r\n</TD>\r\n<TD>\r\n</TD>\r\n</TR>\r\n</TABLE>\r\n</FORM>\r\n</CENTER>\r\n</TD>\r\n</TR>\r\n</TABLE>\r\n</CENTER>\r\n");
	//sprintf(footer,"%s","</BODY>\r\n</HTML>");

	// Begin sending back HTML to the client
	//printf("%s",header);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\r\n\r\n<HTML>\r\n<HEAD>\r\n<TITLE>Appartement</TITLE>\r\n<META NAME=\"subject\" CONTENT=\"Webcam\">\r\n<META HTTP-EQUIV=\"Pragma\" CONTENT=\"no-cache\">\r\n<META HTTP-EQUIV=\"expires\" CONTENT=\"Wed, 26 Feb 1997 08:21:57 GMT\">\r\n<meta http-equiv=\"Refresh\" content=\"69; URL=/cgi-bin/ctrlcam.exe?ACTION=REFRESH\">\r\n</HEAD>\r\n<BODY  BGCOLOR=\"#1C2752\" TEXT=\"#EEEEEE\" LINK=\"#000080\" VLINK=\"#00D502\" ALINK=\"#FF0000\">\r\n\r\n<CENTER>\r\n<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=\"350\">\r\n");
	//printf("<TR>\r\n	<TD ALIGN=Center VALIGN=TOP WIDTH=\"350\">\r\n		<CENTER>\r\n		<A href=\"mailto: myemail?Subject=Webcam1\"><img src=\"../images/webcam.jpg\"    width=\"320\" height=\"240\" border=0 alt=\"Appartement\"></A>        \r\n		</CENTER>\r\n	</TD>\r\n</TR>\r\n");


	
	// Version Formulaire
	printf("<TR>\r\n<TD ALIGN=Center VALIGN=TOP WIDTH=\"350\">\r\n		<CENTER>\r\n		<FORM METHOD=GET ACTION=\"/cgi-bin/ctrlcam.exe\">\r\n			<TABLE BORDER=0 CELLPADDING=10>\r\n			<TR>\r\n				<TD ALIGN=Center VALIGN=Middle>\r\n					<INPUT  NAME=ACTION  TYPE=submit  VALUE=LEFT>\r\n				</TD>\r\n				<TD ALIGN=Center VALIGN=Middle BGCOLOR=#1F2B5F>\r\n					<FONT COLOR=#FF8A00 SIZE=+2>+</FONT>\r\n				</TD>\r\n				<TD ALIGN=Center VALIGN=Middle>\r\n					<INPUT  NAME=ACTION  TYPE=submit  VALUE=RIGHT>\r\n				</TD>\r\n			</TR>\r\n			</TABLE>\r\n		</FORM>\r\n		</CENTER>\r\n	</TD>\r\n</TR>\r\n</TABLE>\r\n</CENTER>\r\n\r\n\r\n");

	// Version Formulaire avec images
	//printf("<TR>\r\n<TD ALIGN=Center VALIGN=TOP WIDTH=\"350\">\r\n<CENTER>\r\n<FORM METHOD=GET ACTION=\"/cgi-bin/ctrlcam.exe\">\r\n<TABLE BORDER=0 CELLPADDING=10>\r\n<TR>\r\n<TD ALIGN=Center VALIGN=Middle>\r\n<INPUT NAME=ACTION VALUE=LEFT TYPE=\"image\" src=\"/images/Arrowlft.png\">\r\n</TD>\r\n<TD ALIGN=Center VALIGN=Middle BGCOLOR=#1C2752>\r\n<FONT COLOR=#FF8A00 SIZE=+2>+</FONT>\r\n</TD>\r\n<TD ALIGN=Center VALIGN=Middle>\r\n<INPUT NAME=ACTION  VALUE=RIGHT TYPE=\"image\" src=\"/images/Arrowrgt.png\">\r\n</TD>\r\n</TR>\r\n</TABLE>\r\n</FORM>\r\n</CENTER>\r\n</TD>\r\n</TR>\r\n</TABLE>\r\n</CENTER>\r\n\r\n\r\n");

	// Version image
	//printf("<TR>\r\n<TD ALIGN=\"Center\" VALIGN=\"TOP\" WIDTH=\"100%\">\r\n<CENTER>\r\n<IMG SRC = \"../../images/basiccontrol.png\"\r\nALIGN  = \"MIDDLE\"\r\nBORDER = \"0\"\r\nHSPACE = \"0\"\r\nWIDTH  = \"105\"\r\nHEIGHT = \"80\"\r\nUSEMAP = \"#CTRLMAP\">\r\n<MAP NAME = \"CTRLMAP\">\r\n<AREA SHAPE=\"RECT\"   COORDS = \"20, 35, 40, 60\" HREF=\"../../cgi-bin/ctrlcam.exe?ACTION=LEFT\" target=\"ctrl\">\r\n<AREA SHAPE=\"RECT\"   COORDS = \"60, 35, 80, 60\" HREF=\"../../cgi-bin/ctrlcam.exe?ACTION=RIGHT\" target=\"ctrl\">\r\n</MAP>\r\n</CENTER>	\r\n</TD>\r\n</TR>\r\n</TABLE>\r\n</CENTER>\r\n\r\n\r\n<BR>\r\n");


	// read the command from the client
	char    *TestLeft="ACTION=LEFT";
	char    *TestRight="ACTION=RIGHT";
	char    *TestTop="ACTION=UP";
	char    *TestBottom="ACTION=DOWN";
	char    *TestGet="GET";
	char    *TestCmd="";
	char	TmpCmd1[100]="";

	// on vrifi que la requete est correcte et le driver dispo
	if( (REQUEST_METHOD != NULL) && ( QUERY_STRING != NULL) && (strcmp("", REQUEST_METHOD) != 0) && (strcmp("", QUERY_STRING) != 0) && (ErreurEndLevel != OPEN_DRIVER_READ_ERR) )
	//if( 1 )
	{
		//lecture du conf register et vrif de la puce
		//ReadConfReg();

		//lecture temprature du DS1720
		/*
		temp1=ReadThermo();
		if(temp1>=256)
			temp1-=512;
		tempc=((float)temp1/2);
		printf("<CENTER><FONT>Temprature de la pice = %.1f C</FONT></CENTER><br>\r\n",tempc);
		*/

		// 
		if( strcmp(TestGet, REQUEST_METHOD) == 0 ) //parse only if there is a method from the client
		//if(1) //parse only if there is a method from the client
		{
			//if (strcmp("", QUERY_STRING) != 0)
			
			// mise ne forme de la commande dans la cas d'un formulaire  base d'images
			// ACTION.x=26&ACTION.y=30&ACTION=LEFT
			strcpy(TmpCmd1, QUERY_STRING);
			TestCmd=strrchr(TmpCmd1, '&');

			//if(TestCmd != NULL)
			//{
				// open parallel port driver under windows NT/2K/XP...
				ErreurEndLevel=InitMount();

				time( &ltime );
				strncpy( DateTime, ctime( &ltime ), 24);

				// commandes 
				if(strcmp(TestLeft, QUERY_STRING) == 0) //parse only if it's a GET method from the client
				{
					// turn the webcam left
					ErreurEndLevel=GoLeft();
					printf ("<CENTER><FONT>Webcam is turning left...</FONT></CENTER>\r\n");
					if ( (fp = fopen("lastmove.txt","w+")) == NULL)
					{
						printf("Error: can't open lastmove.txt for writing.");
					}
					else
					{
						fprintf(fp,"%s \r\n<BR>(IP: %s - Date: %s - Direction: Left)", REMOTE_HOST, REMOTE_ADDR, DateTime);
						fclose(fp);
					}
				}
				else if(strcmp(TestRight, QUERY_STRING) == 0) 
				{
					// turn the webcam right
					ErreurEndLevel=GoRight();
					printf ("<CENTER><FONT>Webcam is turning right...</FONT></CENTER>\r\n");
					if ( (fp = fopen("lastmove.txt","w+")) == NULL)
					{	
						printf("Error: can't open lastmove.txt for writing.");
					}
					else
					{
						fprintf(fp,"%s \r\n<BR>(IP: %s - Date: %s - Direction: Right)", REMOTE_HOST, REMOTE_ADDR, DateTime);
						fclose(fp);
					}
				}
				else if(strcmp(TestTop, QUERY_STRING) == 0) 
				{
					// turn the webcam up
					ErreurEndLevel=GoUp();
					printf ("<CENTER><FONT>Up action is not mechanicaly implemented, try again ! </FONT></CENTER><br>\r\n");
				}
				else if(strcmp(TestBottom, QUERY_STRING) == 0) 
				{
					// turn the webcam down
					ErreurEndLevel=GoDown();
					printf ("<CENTER><FONT>Down action is not mechanicaly implemented, try again ! </FONT></CENTER><br>\r\n");
				}
				else         
				{
					//printf ("<CENTER><FONT>AutoRefresh.</FONT></CENTER><br>\r\n");
				}

				CloseMount(); // close the parallel port driver (under windows NT)
			//}

		} 
		else
		{
			printf ("<CENTER><FONT>Incorrect method, try again with GET!</FONT></CENTER><br>\r\n");
		}
	}
	else if (ErreurEndLevel == OPEN_DRIVER_READ_ERR)
	{
		printf ("<CENTER><FONT>Unable to open the device... Motor azimtuh disabled \n</FONT></CENTER><br>\r\n");
	}
	
	//gethostbyadd()
	//gethostpername() 
	/*
	/* On va maintenant remplir la structure sockaddr_in, qui ressemble a hostent, mais en plus complete. */
	/* On recupere les infos sur l'hote stockees dans h */
	/* memcpy(&sockname.sin_addr.s_addr, h->h_addr, h->h_length); */
	//h = gethostbyname(SERVEUR_VALUE))==NULL
	//h = gethostbyaddr(SERVEUR_VALUE, sizeof(SERVEUR_VALUE), AF_INET);
	//printf("nom : %s", h->h_addr);

//	printf("<CENTER><FONT>Last Moved by : %s </FONT></CENTER>",REMOTE_HOST);

	if ( (fp = fopen("lastmove.txt","r")) == NULL)
	{
		printf("Error: can't open lastmove.txt for reading.");
	}
	else
	{
		//fscanf( fp, "%s", TempBuff );
		fread( TempBuff, sizeof( char ), 200, fp );

		printf("\r\n<CENTER><FONT>Last move by : %s </FONT></CENTER>",TempBuff);
		fclose(fp);
	}

	// send the usefull server variables 
	/*	
	printf ("REQUEST_METHOD : %s <br>\r\n ", REQUEST_METHOD);
	printf ("QUERY_STRING : %s <br>\r\n", QUERY_STRING);
	printf("%s - %s", TmpCmd1, TestCmd);

	printf ("REMOTE_ADDR : %s <br>\r\n", REMOTE_ADDR);
	printf ("REMOTE_HOST : %s <br>\r\n", REMOTE_HOST);
	printf ("REMOTE_USER : %s <br>\r\n", REMOTE_USER);
	printf ("SERVER_SOFTWARE : %s <br>\r\n", SERVER_SOFTWARE);
	printf ("SERVER_NAME : %s <br>\r\n", SERVER_NAME);
	printf ("SERVER_PORT : %s <br>\r\n", SERVER_PORT);
	printf ("<hr>\r\n");
	*/
	// Ending sending back HTML to the client
	//printf("%s",footer);
	printf("\r\n\r\n</BODY>\r\n</HTML>");

	
		


	//criture d'un fichier log pour surveiller l'activit

	if ( (fp = fopen("camctrl.txt","a+")) == NULL)
	{
        printf("Error: can't open camctrl.txt for writing.");
    }
	else
	{
		/*time( &ltime );
		strncpy( DateTime, ctime( &ltime ), 24);
		*/
		fprintf(fp,"%s - URL: %s - REMOTE_ADDR: %s - REQUEST_METHOD: %s - QUERY_STRING: %s - REMOTE_HOST: %s - SERVER_NAME: %s - SERVER_PORT: %s - SERVER_PORT_SECURE: %s -  SERVER_PROTOCOL: %s - SERVER_SOFTWARE: %s \n", DateTime, URL, REMOTE_ADDR, REQUEST_METHOD, QUERY_STRING, REMOTE_HOST, SERVER_NAME, SERVER_PORT, SERVER_PORT_SECURE, SERVER_PROTOCOL, SERVER_SOFTWARE );
		fclose(fp);
    }


	
	return 0;
}

