#ifndef _MY_TYPES
#define _MY_TYPES


//********* typedef ************

typedef char i8;
typedef unsigned char u8;
typedef short i16;
typedef unsigned short u16;
typedef long i32;
typedef unsigned long u32;
typedef float f32;
typedef double f64;


#define SERVER_SOFTWARE getenv("SERVER_SOFTWARE")
#define	REQUEST_METHOD	getenv("REQUEST_METHOD")
#define	QUERY_STRING	getenv("QUERY_STRING")
#define REMOTE_ADDR		getenv("REMOTE_ADDR")
#define REMOTE_HOST		getenv("REMOTE_HOST")
#define REMOTE_USER		getenv("REMOTE_USER")
#define SERVER_NAME		getenv("SERVER_NAME")
#define SERVER_PORT		getenv("SERVER_PORT")
#define REMOTE_USER		getenv("REMOTE_USER")
#define SCRIPT_NAME		getenv("SCRIPT_NAME")
#define URL				getenv("URL")
#define SERVER_PORT_SECURE	getenv("SERVER_PORT_SECURE")
#define SERVER_PROTOCOL	getenv("SERVER_PROTOCOL")


#define ParallelPortBaseAddress	0x378

#define ENABLED 1
#define DISABLE 0

#define BUFF_MAX 256 // The size of the buffers that have to do with opening a file

#define MAX_LOADSTRING 100
#define NOMBRE_DE_PAS	100
#define COK						0
#define CNOK					-1
#define MOTOR_ERROR			1
#define OPEN_DRIVER_READ_ERR	4
#define OPEN_DRIVER_WRITE_ERR	5
#define CLOSE_DRIVER_ERR		6
#define READ_ERROR				-1
#define WRITE_ERROR				-2
#define FILE_WRITE_ERROR		-3
#define FILE_OPEN_ERROR			-4

#endif
